/*	BSDI net_proto.c,v 2.3 1996/12/31 20:31:43 karels Exp	*/

/*
 * Copyright (c) 1988, 1991, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	from @(#)rtsock.c	8.3 (Berkeley) 1/4/94
 */

#include <sys/param.h>
#include <sys/systm.h>
#include <sys/mbuf.h>
#include <sys/socket.h>
#include <sys/socketvar.h>
#include <sys/domain.h>
#include <sys/protosw.h>

#include <net/raw_cb.h>

/*
 * Definitions of protocols supported in the ROUTE domain.
 */

int	route_output __P((struct mbuf *, struct socket *so));
int	route_usrreq __P((struct socket *, int, struct mbuf *, struct mbuf *,
			struct mbuf *));
int	route_sysctl __P((int *, int, caddr_t, size_t *, caddr_t *, size_t));
void	route_init __P((void));

extern	struct domain routedomain;		/* or at least forward */

struct protosw routesw[] = {
{ SOCK_RAW,	&routedomain,	0,		PR_ATOMIC|PR_ADDR,
  0,		route_output,	raw_ctlinput,	0,
  route_usrreq,
  0,		0,		0,		0,
  route_sysctl,
}
};

struct domain routedomain =
    { PF_ROUTE, "route", route_init, 0, 0,
      routesw, &routesw[sizeof(routesw)/sizeof(routesw[0])] };


/*
 * Definitions of protocols supported in the LINK domain.
 */
void	link_input __P((struct mbuf *, struct ifnet *, void *, void *));
int	link_output __P((struct mbuf *, struct socket *));
int	link_ctloutput __P((int, struct socket *, int, int, struct mbuf **));
int	link_sysctl __P((int *, int, caddr_t, size_t *, caddr_t *, size_t));

extern	struct domain linkdomain;		/* or at least forward */

struct protosw linksw[] = {
{ SOCK_RAW,	&linkdomain,	0,		PR_ATOMIC|PR_ADDR,
  0,		link_output,	raw_ctlinput,	link_ctloutput,
  raw_usrreq,
  0,		0,		0,		0,
  link_sysctl,
}
};

struct domain linkdomain =
    { PF_LINK, "link", 0, 0, 0,
      linksw, &linksw[sizeof(linksw)/sizeof(linksw[0])] };
