/* ber.h: declarations for ber.c */

#ifndef SNOOP_BER_H
#define SNOOP_BER_H

#define MODEL		"poisson"

#define BER_POISSON	0
#define BER_MARKOV	1


/* ERR_PROBs are scaled by 1e9 */
#define ERR_PROB0		65536
#define ERR_PROB1		1000000
#define TRANS_PERC0		30
#define TRANS_PERC1		70

#if !defined(TIMEV)
typedef struct timeval timev;
#endif

struct ber_state {
	int     model;
	int     bytes_to_next_error; 
	u_char  protocol;
	u_short port;		/* which TCP port? 0 ==> all ports */
	
	int     burst_rate;	/* number pf pkts to blow away */

	/* Update rate of Markov state machine 100 ms */
	int     time_granularity; /* time granularity of call */
	timev   last_call_time;

	/* This is private state dependent on the error model used */
	int     markov_state;
	int     trans_perc[2];
	int     error_prob[2];
	int     disable;  /* 1 if error generation is disabled, 0 otherwise */ 
};

extern struct   ber_state ber;

#define RAND_MEAN (1<<28)
#define NUM_RANDS 50000

void ber_init __P ((void));
int  wireless_drop __P((struct mbuf *, int));
		      
#endif /* SNOOP_BER_H */
